Option Strict On
Public Class DeclareFn
    ' assumes use1432.dll is in system diretory
    ' this is little more than a wrapper for VB.NET calls,
    ' using some overloading
    ' note Option Strict On - avoids errors

    ' VB.NET 1.1, jg colebatch Sept 2006
    ' does not cover all the functions exported by use1432
    ' does not have a "strong name" thus, to use this
    ' copy to it to the bin directory of project and add reference to it
    ' thus, for example:  Dim my1432class as New U1432Class.DeclareFn
    ' NOTE Alias's are case-sensitive as well as function overloading


    Public Declare Function U14LastErrCode Lib "use1432" Alias "U14LastErrCode" (ByVal hand As Int16) As Int16

    Public Declare Function U14Open1401 Lib "Use1432" Alias "U14Open1401" (ByVal n1401 As Int16) As Int16
    Public Declare Function U14Close1401 Lib "Use1432" Alias "U14Close1401" (ByVal hand As Int16) As Int16
    Public Declare Function U14Reset1401 Lib "Use1432" Alias "U14Reset1401" (ByVal hand As Int16) As Int16
    Public Declare Function U14TypeOf1401 Lib "Use1432" Alias "U14TypeOf1401" (ByVal hand As Int16) As Int16

    Public Declare Function U14Stat1401 Lib "use1432" Alias "U14Stat1401" (ByVal hand As Int16) As Int16
    Public Declare Function U14CharCount Lib "use1432" Alias "U14CharCount" (ByVal hand As Int16) As Int16
    Public Declare Function U14LineCount Lib "use1432" Alias "U14LineCount" (ByVal hand As Int16) As Int16

    Public Declare Function U14SendString Lib "use1432" Alias "U14SendString" (ByVal hand As Int16, ByVal PString As String) As Int16

    'overload to allow use of unsigned int16 maxlen if desired
    Public Declare Function U14GetString Lib "use1432" Alias "U14GetString" (ByVal hand As Int16, ByVal lpBuffer As String, ByVal wMaxLen As UInt16) As Int16
    Public Declare Function U14GetString Lib "use1432" Alias "U14GetString" (ByVal hand As Int16, ByVal lpBuffer As String, ByVal maxLen As Int16) As Int16

    Public Declare Function U14LdCmd Lib "use1432" Alias "U14LdCmd" (ByVal hand As Int16, ByVal comStr As String) As Int32
    Public Declare Function U14Ld Lib "use1432" Alias "U14Ld" (ByVal hand As Int16, ByVal vl As String, ByVal comStr As String) As Int32
    ' overload to allow return of byte or int16 data
    Public Declare Function U14SetTransArea Lib "use1432" Alias "U14SetTransArea" (ByVal hand As Int16, ByVal wArea As Int16, ByRef lpBuff As Int16, ByVal dwLength As Int32, ByVal eSz As Int16) As Int16
    Public Declare Function U14SetTransArea Lib "use1432" Alias "U14SetTransArea" (ByVal hand As Int16, ByVal wArea As Int16, ByRef lpBuff As Byte, ByVal dwLength As Int32, ByVal eSz As Int16) As Int16
    Public Declare Function U14UnSetTransfer Lib "use1432" Alias "U14UnSetTransfer" (ByVal hand As Int16, ByVal wArea As Int16) As Int16
    ' also overloaded U14ToHost for 16 and 8 bit data, with unsigned and signed int32 as "As Any" not permitted
    Public Declare Function U14ToHost Lib "use1432" Alias "U14ToHost" (ByVal hand As Int16, ByRef lpHost As Int16, ByVal dwSz As Int32, ByVal dwA1401 As Int32, ByVal eSz As Int16) As Int16
    Public Declare Function U14ToHost Lib "use1432" Alias "U14ToHost" (ByVal hand As Int16, ByRef lpHost As Int16, ByVal dwSz As UInt32, ByVal dwA1401 As UInt32, ByVal eSz As Int16) As Int16
    Public Declare Function U14ToHost Lib "use1432" Alias "U14ToHost" (ByVal hand As Int16, ByRef lpHost As Byte, ByVal dwSz As Int32, ByVal dwA1401 As Int32, ByVal eSz As Int16) As Int16
    Public Declare Function U14ToHost Lib "use1432" Alias "U14ToHost" (ByVal hand As Int16, ByRef lpHost As Byte, ByVal dwSz As UInt32, ByVal dwA1401 As UInt32, ByVal eSz As Int16) As Int16
    ' overloaded U14To1401 for unsigned or signed int32, byte array version no written
    Public Declare Function U14To1401 Lib "use1432" Alias "U14To1401" (ByVal hand As Int16, ByRef lpHost As Int16, ByVal dwSz As UInt32, ByVal dwA1401 As UInt32, ByVal eSz As Int16) As Int16
    Public Declare Function U14To1401 Lib "use1432" Alias "U14To1401" (ByVal hand As Int16, ByRef lpHost As Int16, ByVal dwSz As Int32, ByVal dwA1401 As Int32, ByVal eSz As Int16) As Int16

    Public Declare Function U14StrToLongs Lib "use1432" Alias "U14StrToLongs" (ByVal lpStr As String, ByRef palNums As Int32, ByVal sMax As Int16) As Int16
    Public Declare Function U14LongsFrom1401 Lib "use1432" Alias "U14LongsFrom1401" (ByVal hand As Int16, ByRef palNums As Int32, ByVal sMax As Int16) As Int16

    Public Declare Sub U14SetTimeout Lib "use1432" Alias "U14SetTimeout" (ByVal hand As Int16, ByVal lTimeOut As Int32)
    Public Declare Function U14GetTimeOut Lib "use1432" Alias "U14GetTimeout" (ByVal hand As Int16) As Int32
    Public Declare Function U14OutBufSpace Lib "use1432" Alias "U14OutBufSpace" (ByVal hand As Int16) As Int16
    Public Declare Function U14BaseAddr1401 Lib "use1432" Alias "U14BaseAddr1401" (ByVal hand As Int16) As Int32
    Public Declare Function U14DriverVersion Lib "use1432" Alias "U14DriverVersion" () As Int32
    Public Declare Function U14DriverType Lib "use1432" Alias "U14DriverType" () As Int32
    Public Declare Function U14GetUserMemorySize Lib "use1432" Alias "U14GetUserMemorySize" (ByVal hand As Int16, ByRef memorySize As Int32) As Int16
    Public Declare Function U14KillIO1401 Lib "use1432" Alias "U14KillIO1401" (ByVal hand As Int16) As Int16

    Public Declare Function U14StateOf1401 Lib "use1432" Alias "U14StateOf1401" (ByVal hand As Int16) As Int16

    Public Declare Function U14TransferFlags Lib "use1432" Alias "U14TransferFlags" (ByVal hand As Int16) As Int16
    ' used int16 in next call, can overload with uint16 if desired 
    Public Declare Sub U14GetErrorString Lib "use1432" Alias "U14GetErrorString" (ByVal hand As Int16, ByVal ustring As String, ByVal wMax As Int16)
    Public Declare Function U14MonitorRev Lib "use1432" Alias "U14MonitorRev" (ByVal hand As Int16) As Int32

    Public Function DecipherErr16(ByVal err16 As Int16) As String
        ' this just wraps U14GetErrorString and is tidier
        Dim errStr As New String(CChar("0"), 255)
        U14GetErrorString(err16, errStr, 255)
        DecipherErr16 = errStr
    End Function

    Public Const U14ERR_NOERROR As Int16 = 0  ' int16 version
    Public Const U14ERR_NOERROR32 As Int32 = 0 ' int32 version
    Public Const U14ERR_OFF As Int16 = -500
    Public Const U14ERR_NC As Int16 = -501
    Public Const U14ERR_ILL As Int16 = -502
    Public Const U14ERR_NOIF As Int16 = -503
    Public Const U14ERR_TIME As Int16 = -504
    Public Const U14ERR_BADSW As Int16 = -505
    Public Const U14ERR_PTIME As Int16 = -506
    Public Const U14ERR_NOINT As Int16 = -507
    Public Const U14ERR_NODMA As Int16 = -508
    Public Const U14ERR_BADHAND As Int16 = -510
    Public Const U14ERR_BAD1401NUM As Int16 = -511

    Public Const U14ERR_NO_SUCH_FN As Int16 = -520
    Public Const U14ERR_NO_SUCH_SUBFN As Int16 = -521
    Public Const U14ERR_ERR_NOOUT As Int16 = -522
    Public Const U14ERR_ERR_NOIN As Int16 = -523
    Public Const U14ERR_ERR_STRLEN As Int16 = -524
    Public Const U14ERR_LOCKFAIL As Int16 = -525
    Public Const U14ERR_UNLOCKFAIL As Int16 = -526
    Public Const U14ERR_ALREADYSET As Int16 = -527
    Public Const U14ERR_NOTSET As Int16 = -528
    Public Const U14ERR_BADAREA As Int16 = -529

    Public Const U14ERR_NOFILE As Int16 = -540
    Public Const U14ERR_READERR As Int16 = -541
    Public Const U14ERR_UNKNOWN As Int16 = -542
    Public Const U14ERR_HOSTSPACE As Int16 = -543
    Public Const U14ERR_LOCKERR As Int16 = -544
    Public Const U14ERR_CLOADERR As Int16 = -545

    Public Const U14ERR_TOXXXERR As Int16 = -560

    Public Const U14ERR_NO386ENH As Int16 = -580  ' (obsolete)
    Public Const U14ERR_NO1401DRIV As Int16 = -581
    Public Const U14ERR_DRIVTOOOLD As Int16 = -582

    Public Const U14ERR_TIMEOUT As Int16 = -590

    Public Const U14ERR_BUFF_SMALL As Int16 = -600
    Public Const U14ERR_CBALREADY As Int16 = -601
    Public Const U14ERR_BADEREG As Int16 = -602

    Public Const U14ERR_DRIVCOMMS As Int16 = -610
    Public Const U14ERR_OUTOFMEMORY As Int16 = -611

    Public Const U14TYPE1401 As Int16 = 0     ' Standard 1401
    Public Const U14TYPEPLUS As Int16 = 1     ' 1401plus
    Public Const U14TYPEU1401 As Int16 = 2    ' Micro1401
    Public Const U14TYPEPOWER As Int16 = 3    ' Power1401
    Public Const U14TYPEU1401MK2 As Int16 = 4     ' Micro1401MkII
    Public Const U14TYPEUNKNOWN As Int16 = -1 ' unknown type

    Public Const U14TF_USEDMA As Int16 = 1
    Public Const U14TF_MULTIA As Int16 = 2
    Public Const U14TF_FIFO As Int16 = 4


    Public Const U14TF_DIAG As Int16 = 256

End Class
